﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO.Ports;
using System.IO;

namespace MyTcpListener
{
    public partial class Form1 : Form
    {
        int gX0 = 0;//X現在座標
        int gY0 = 0;//Y現在座標
        int gZ0 = 0;//Z現在座標
        String gText;//受信データ
        int gM = 0;//処理モード
        int gS = 0;//シーケンスNo
        int VthAD;//与圧の閾値
        int gZ2;//Zサーチ結果

        Bitmap image1;//入力画像データ
        int[,] mZ = new int[50, 50];//加工面計測値
        int[,] gMap = new int[50, 50];//Mapデータ
        int gW, gH;//画像幅、高さ
        int gPw, gPh;//幅、高さ送りピッチ
        int gi, gj;//幅、高さカウンタ

        int fBX = 1;//バックラッシュフラグ
        int gCT;//タイムカウンタ
        int gCTN;//連続回転時間
        int gCK;//'回数カウンタ
        int gCKN;//加工回数

        int gZSP;//サーチピッチ
        int gi0Z;//gi=0時のZ退避量
        int gi1Z;//gi>0時のZ退避量
        int gKZ0;//加工開始Z位置
        int gKZP;//加工Z送り量
        int fVth = 0;//Vthフラグ

        int gLT = 0;//ロスタイムカウンタ



        TcpListener server = null;
        int gNo = 0;
        bool fOK = true;
        Int32 port;
        IPAddress localAddr;
        Byte[] bytes = new Byte[256];
        String data = null;
        TcpClient client;
        NetworkStream stream;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            button21.Enabled = true;
            button22.Enabled = false;
            button23.Enabled = false;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (fOK)
            {
                fOK = false;
                TimeP();

                switch (gM)
                {
                    case 1:
                        F1();//Zサーチ
                        break;
                    case 2:
                        F2();//加工面計測
                        break;
                    case 3:
                        F3();//加工
                        break;
                    default:
                        break;
                }
                fOK = true;
            }

            
        }

        void TimeP()
        {
            
            switch (gNo)
            {
                case 1:
                    textBox23.AppendText("接続待ち\r\n");
                    textBox23.AppendText("接続待ちで強制終了する場合は、タスクマネージャーを使用してください！！\r\n");
                    server.Start();
                    client = server.AcceptTcpClient();
                    textBox23.AppendText("接続完了\r\n");
                    stream = client.GetStream();
                    gNo = 3;
                    button23.Enabled = true;
                    break;
                case 3:
                    if (stream.DataAvailable)
                    {
                        int i = stream.Read(bytes, 0, bytes.Length);

                        if (i != 0)
                        {
                            data = System.Text.Encoding.ASCII.GetString(bytes, 0, i);
                            if (gM < 2) { textBox23.AppendText(data); }
                            gText =gText+ data;
                            data = "";
                        }
                    }
                    break;
                default:
                    break;
            }
            
        }

        private void button21_Click(object sender, EventArgs e)
        {
            port = Convert.ToInt32(textBox21.Text); 
            IPHostEntry ipHostInfo = Dns.Resolve(Dns.GetHostName());
            localAddr = ipHostInfo.AddressList[0];
            server = new TcpListener(localAddr, port);
            
            gNo = 1;
            button21.Enabled = false;
            button22.Enabled = true;
            button23.Enabled = true;
        }

        private void button22_Click(object sender, EventArgs e)
        {
            gNo = 0;
            server.Stop();
            client.Close();
            client = null;
            button21.Enabled = true;
            button22.Enabled = false;
            button23.Enabled = false;
        }

        private void button23_Click(object sender, EventArgs e)
        {
            byte[] msg = System.Text.Encoding.ASCII.GetBytes(textBox22.Text + "\r\n");
            stream.Write(msg, 0, msg.Length);
            gNo = 3;  
        }

        

        private void Button1_Click(object sender, EventArgs e)
        {
            gW = Convert.ToInt32(TextBox1.Text);
            gH = Convert.ToInt32(TextBox2.Text);
            gPw = Convert.ToInt32(TextBox3.Text);
            gPh = Convert.ToInt32(TextBox4.Text);

            gZSP = Convert.ToInt32(TextBox5.Text);
            gi0Z = Convert.ToInt32(TextBox6.Text);
            gi1Z = Convert.ToInt32(TextBox7.Text);
            gCTN = Convert.ToInt32(TextBox8.Text);
            gCKN = Convert.ToInt32(TextBox9.Text);
            gKZ0 = Convert.ToInt32(TextBox10.Text);
            gKZP = Convert.ToInt32(TextBox11.Text);

            String test = gKZ0.ToString();


            gM = 1;
            gS = 0;
            textBox23.Text = "";
            gZSP = Convert.ToInt16(TextBox5.Text);
        }
        void F1()//Zサーチ
        {
            String str;
            int AD;
            byte[] msg = new byte[256];


            switch (gS)
            {
                case 0:
                    gText = "";
                    msg = System.Text.Encoding.ASCII.GetBytes("MA#0#0#0#");
                    stream.Write(msg, 0, msg.Length);
                    //SerialPort1.Write("MA#0#0#0#");
                    gS = 1;

                    fVth = 0;
                    gLT = 0;//ロスタイム
                    break;
                case 1:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC") { gS = 2; }
                    }
                    gLT++;
                    if (gLT > 20) { gS = 0; }//ロスタイムオーバー
                    break;
                case 2:
                    gText = "";
                    msg = System.Text.Encoding.ASCII.GetBytes("AD#");
                    stream.Write(msg, 0, msg.Length);
                    //stream.Write(msg, 0, msg.Length);
                    //SerialPort1.Write("AD#");
                    gS = 3;
                    gLT = 0;//ロスタイム
                    break;
                case 3:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "AD")
                        {
                            //textBox23.AppendText("Z0\t" + gZSP.ToString() + "\r\n");
                            str = gText.Substring(3, gText.IndexOf('\n') - 4);
                            AD = Convert.ToInt32(str);
                            if (fVth == 0) { VthAD = (AD * 90) / 100; }
                            fVth = 1;
                            if (AD > VthAD)
                            {
                                gZ0 = gZ0 + gZSP;
                                gText = "";
                                msg = System.Text.Encoding.ASCII.GetBytes("MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#");
                                //msg = System.Text.Encoding.ASCII.GetBytes("MR#0#0#" + gZSP.ToString() + "#");
                                stream.Write(msg, 0, msg.Length);
                                //stream.Write(msg, 0, msg.Length);
                                //SerialPort1.Write("MR#0#0#" + gZSP.ToString() + "#");

                                
                                gS = 4;
                                gLT = 0;//ロスタイム
                            }
                            else
                            {
                                gS = 5;
                            }
                        }
                    }
                    gLT++;
                    if (gLT > 20) { gS = 2; }//ロスタイムオーバー
                    break;
                case 4:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC") { gS = 2; }
                    }
                    gLT++;
                    if (gLT > 20)
                    {
                        gZ0 = gZ0 - gZSP;
                        gS = 3;
                    }//ロスタイムオーバー
                    break;
                case 5:
                    gZ2 = gZ0; //Zサーチ結果
                    textBox23.AppendText("END\r\n");
                    gS = 6;
                    break;
                case 6:
                    break;
                default:
                    break;
            }
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            gW = Convert.ToInt32(TextBox1.Text);
            gH = Convert.ToInt32(TextBox2.Text);
            gPw = Convert.ToInt32(TextBox3.Text);
            gPh = Convert.ToInt32(TextBox4.Text);

            gZSP = Convert.ToInt32(TextBox5.Text);
            gi0Z = Convert.ToInt32(TextBox6.Text);
            gi1Z = Convert.ToInt32(TextBox7.Text);
            gCTN = Convert.ToInt32(TextBox8.Text);
            gCKN = Convert.ToInt32(TextBox9.Text);
            gKZ0 = Convert.ToInt32(TextBox10.Text);
            gKZP = Convert.ToInt32(TextBox11.Text);

            if (gM == 1 && gS == 6)
            {
                gi = 0;
                gj = 0;
                gM = 2;
                gS = 0;
                textBox23.Text = "";
                textBox23.AppendText("i\tj\tgZ0\r\n");
            }
            else { MessageBox.Show("Zサーチを実行してください！！"); }
        }

        void F2()//加工面計測
        {
            String str;
            int x, y, z, AD;
            byte[] msg = new byte[256];

            switch (gS)
            {
                case 0:
                    x = (gi - gW / 2) * gPw;
                    y = (gj - gH / 2) * gPh;
                    if (gi == 0)
                    {
                        z = gZ2 + gi0Z;//Zサーチ結果+gi=0時のZ退避量
                    }
                    else
                    {
                        z = gZ2 + gi1Z;//Zサーチ結果+gi=0時以外のZ退避量
                    }
                    gText = "";
                    msg = System.Text.Encoding.ASCII.GetBytes("MA#" + x.ToString() + "#" + y.ToString() + "#" + z.ToString() + "#");       
                    stream.Write(msg, 0, msg.Length);
                    //SerialPort1.Write("MA#" + x.ToString() + "#" + y.ToString() + "#" + z.ToString() + "#");
                    gS = 1;

                    gX0 = x; gY0 = y; gZ0 = z;
                     gLT = 0;//ロスタイム
                    break;

                case 1:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC") { gS = 2; }
                    }
                    gLT++;
                    if (gLT > 20) { gS = 0; }//ロスタイムオーバー
                    break;

                case 2:
                    gText = "";
                    msg = System.Text.Encoding.ASCII.GetBytes("AD#");       
                    stream.Write(msg, 0, msg.Length);
                    //SerialPort1.Write("AD#");
                    gS = 3;
                    gLT = 0;//ロスタイム
                    break;

                case 3:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "AD")
                        {
                            str = gText.Substring(3, gText.IndexOf('\n') - 4);
                            AD = Convert.ToInt32(str);

                            if (AD > VthAD)
                            {
                                gZ0 = gZ0 + gZSP;
                                gText = "";
                                msg = System.Text.Encoding.ASCII.GetBytes("MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#");
                                //msg = System.Text.Encoding.ASCII.GetBytes("MR#0#0#" + gZSP.ToString() + "#");
                                stream.Write(msg, 0, msg.Length);
                                //SerialPort1.Write("MR#0#0#" + gZSP.ToString() + "#");

                                
                                gS = 4;
                                gLT = 0;//ロスタイム
                            }
                            else { gS = 5; }
                        }
                    }
                    gLT++;
                    if (gLT > 20) { gS = 2; }//ロスタイムオーバー
                    break;

                case 4:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC") { gS = 2; }
                    }
                    gLT++;
                    if (gLT > 20) 
                    {
                        gZ0 = gZ0 - gZSP;
                        gS = 3;
                    }//ロスタイムオーバー
                    break;

                case 5:
                    mZ[gi, gj] = gZ0;// 'Zサーチ結果
                    textBox23.AppendText(gi.ToString() + "\t" + gj.ToString() + "\t" + gZ0.ToString() + "\r\n");
                    if (gi < gW - 1)
                    {
                        gi = gi + 1;
                        gS = 0;
                    }
                    else
                    {
                        if (gj < gH - 1)
                        {
                            gi = 0;
                            gj = gj + 1;
                            gS = 0;
                        }
                        else
                        {
                            gS = 6;
                        }
                    }
                    break;

                case 6:
                    break;

                default:
                    break;
            }

        }

        private void Button3_Click(object sender, EventArgs e)
        {
            int i, j;
            String OutText = "\\\t";

            for (i = 0; i < gW; i++)
            {
                OutText = OutText + "i=" + i.ToString() + "\t";
            }
            OutText = OutText + "\r\n";

            for (j = 0; j < gH; j++)
            {
                OutText = OutText + "j=" + j.ToString() + "\t";
                for (i = 0; i < gW; i++)
                {
                    OutText = OutText + mZ[i, j].ToString() + "\t";
                }
                OutText = OutText + "\r\n";
            }
            if (SaveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                using (StreamWriter outfile = new StreamWriter(SaveFileDialog1.FileName))
                {
                    outfile.Write(OutText);
                }
            }

        }

        private void Button4_Click(object sender, EventArgs e)
        {
            if (gM == 1 && gS == 6)
            {
                if (OpenFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    textBox23.Text = "";
                    image1 = new Bitmap(OpenFileDialog1.FileName);
                    PictureBox1.Load(OpenFileDialog1.FileName);

                    int x, y;
                    TextBox1.Text = image1.Width.ToString();
                    TextBox2.Text = image1.Height.ToString();
                    gW = Convert.ToInt32(TextBox1.Text);
                    gH = Convert.ToInt32(TextBox2.Text);
                    gPw = Convert.ToInt32(TextBox3.Text);
                    gPh = Convert.ToInt32(TextBox4.Text);

                    gZSP = Convert.ToInt32(TextBox5.Text);
                    gi0Z = Convert.ToInt32(TextBox6.Text);
                    gi1Z = Convert.ToInt32(TextBox7.Text);
                    gCTN = Convert.ToInt32(TextBox8.Text);
                    gCKN = Convert.ToInt32(TextBox9.Text);
                    gKZ0 = Convert.ToInt32(TextBox10.Text);
                    gKZP = Convert.ToInt32(TextBox11.Text);

                    textBox23.AppendText("X\tY\tII\r\n");


                    for (y = 0; y < image1.Height; y++)
                    {
                        for (x = 0; x < image1.Width; x++)
                        {
                            Color pixelColor = image1.GetPixel(x, image1.Height - 1 - y);
                            gMap[x, y] = pixelColor.R + pixelColor.G + pixelColor.B;
                            textBox23.AppendText(x.ToString() + "\t" + y.ToString() + "\t" + gMap[x, y].ToString() + "\r\n");
                            mZ[x, y] = 0;
                        }
                    }
                    gi = 0;
                    gj = 0;
                    fBX = 1;
                    gM = 3;
                    gS = 0;

                    textBox23.AppendText("\r\ni\tj\tgZ0\r\n");

                }
            }
            else
            {
                MessageBox.Show("Zサーチを実行してください！！");
            }

        }

        void F3()//加工実行
        {
            String str;
            int x, y, z, AD;
            byte[] msg = new byte[256];

            switch (gS)
            {
                case 0:
                    gCK = 0;
                    if (gMap[gi, gj] < 384)
                    { gS = 20; }
                    else { gS = 210; }
                    break;
                case 20:
                    if (fBX == 1)
                    {
                        gZ0 = gZ0 + gi0Z;
                        gText = "";
                        msg = System.Text.Encoding.ASCII.GetBytes("MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#");
                        //msg = System.Text.Encoding.ASCII.GetBytes("MR#0#0#" + gi0Z.ToString() + "#");
                        stream.Write(msg, 0, msg.Length);//Z退避初回相対移動
                        //SerialPort1.Write("MR#0#0#" + gi0Z.ToString() + "#"); //Z退避初回相対移動
                        
                        gS = 21;
                        gLT = 0;//ロスタイム
                    }
                    else
                    {
                        gZ0 = gZ0 + gi0Z;
                        gText = "";
                        msg = System.Text.Encoding.ASCII.GetBytes("MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#");
                        //msg = System.Text.Encoding.ASCII.GetBytes("MR#0#0#" + gi1Z.ToString() + "#");
                        stream.Write(msg, 0, msg.Length);//Z退避初回以外相対移動
                        //SerialPort1.Write("MR#0#0#" + gi1Z.ToString() + "#"); //Z退避初回以外相対移動
                        
                        gS = 21;
                        gLT = 0;//ロスタイム
                    }
                    break;
                case 21:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC") { gS = 22; }//Z退避完了
                    }
                    gLT++;
                    if (gLT > 20) 
                    {
                        gZ0 = gZ0 - gi0Z;
                        gS = 20; 
                    }//ロスタイムオーバー
                    break;
                case 22:
                    if (fBX == 1)
                    {
                        x = (gi - gW / 2) * gPw - 500;//Xバックラッシュ補正
                        y = (gj - gH / 2) * gPh - 500;//Yバックラッシュ補正
                        z = gZ2 + gi0Z;//Z退避初回
                        //初回絶対値移動
                        gText = "";
                        msg = System.Text.Encoding.ASCII.GetBytes("MA#" + x.ToString() + "#" + y.ToString() + "#" + z.ToString() + "#");
                        stream.Write(msg, 0, msg.Length);//初回絶対値移動
                        //SerialPort1.Write("MA#" + x.ToString() + "#" + y.ToString() + "#" + z.ToString() + "#");
                        gS = 23;
                        gX0 = x; gY0 = y; gZ0 = z;
                        fBX = 0;//初回完了
                        gLT = 0;//ロスタイム
                    }
                    else
                    {
                        gS = 110;
                    }
                    break;
                case 23:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC") { gS = 110; }//初回以外移動へ行く
                    }
                    gLT++;
                    if (gLT > 20) { gS = 22; }//ロスタイムオーバー
                    break;
                case 110:
                    x = (gi - gW / 2) * gPw;
                    y = (gj - gH / 2) * gPh;
                    if (fBX == 1)
                    { z = gZ2 + gi0Z; }//初回加工Z位置
                    else { z = gZ2 + gi1Z; }//初回以外加工Z位置
                    gText = "";
                    //加工位置絶対値移動
                    msg = System.Text.Encoding.ASCII.GetBytes("MA#" + x.ToString() + "#" + y.ToString() + "#" + z.ToString() + "#");
                    stream.Write(msg, 0, msg.Length);//加工位置絶対値移動
                    //SerialPort1.Write("MA#" + x.ToString() + "#" + y.ToString() + "#" + z.ToString() + "#");
                    gS = 120;
                    gX0 = x; gY0 = y; gZ0 = z;
                    gLT = 0;//ロスタイム
                    break;
                case 120:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC") { gS = 130; }//圧力測定へ行く
                    }
                    gLT++;
                    if (gLT > 10) { gS = 110; }//ロスタイムオーバー
                    break;
                case 130:
                    gText = "";
                    msg = System.Text.Encoding.ASCII.GetBytes("AD#");
                    stream.Write(msg, 0, msg.Length);//
                    //SerialPort1.Write("AD#");
                    gS = 140;
                    gLT = 0;//ロスタイム
                    break;
                case 140:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "AD")
                        {
                            str = gText.Substring(3,gText.IndexOf('\n')-4);
                            AD = Convert.ToInt32(str);
                            if (AD > VthAD)
                            {
                                gZ0 = gZ0 + gZSP;
                                gText = "";
                                msg = System.Text.Encoding.ASCII.GetBytes("MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#");
                                //msg = System.Text.Encoding.ASCII.GetBytes("MR#0#0#" + gZSP.ToString() + "#");
                                stream.Write(msg, 0, msg.Length);//Z相対追加移動
                                //SerialPort1.Write("MR#0#0#" + gZSP.ToString() + "#");//Z相対追加移動
                                
                                gS = 150;
                                gLT = 0;//ロスタイム
                            }
                            else { gS = 160; }//Z相対追加移動完了
                        }
                    }
                    gLT++;
                    if (gLT > 20) { gS = 130; }//ロスタイムオーバー
                    break;
                case 150:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC") { gS = 130; }//圧力測定へ行く
                    }
                    gLT++;
                    if (gLT > 10) 
                    {
                        gZ0 = gZ0 - gZSP;
                        gS = 140;
                    }//ロスタイムオーバー
                    break;
                case 160:
                    mZ[gi, gj] = gZ0;//Zサーチ結果
                    textBox23.AppendText(gi.ToString() + "\t" + gj.ToString() + "\t" + gZ0.ToString() + "\r\n");
                    gS = 165;
                    break;

                case 165:

                    gZ0 = gZ0 + gKZ0;
                    gText = "";
                    msg = System.Text.Encoding.ASCII.GetBytes("MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#");
                    //msg = System.Text.Encoding.ASCII.GetBytes("MR#0#0#" + gKZ0.ToString() + "#");   
                    stream.Write(msg, 0, msg.Length);//Z退避移動
                    //SerialPort1.Write("MR#0#0#" + gKZ0.ToString() + "#");//Z退避移動
                    
                    gS = 170;
                    gLT = 0;//ロスタイム
                    break;
                case 170:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC")
                        {
                            gText = "";
                            msg = System.Text.Encoding.ASCII.GetBytes("DC#1#");
                            stream.Write(msg, 0, msg.Length);//DCモータON
                            //System.Threading.Thread.Sleep(5);
                            stream.Write(msg, 0, msg.Length);//DCモータON
                            //SerialPort1.Write("DC#1#");//DCモータON
                            gCT = 0;// タイムカウンタ
                            //gCK = 0;//回数カウンタ
                            gS = 175;
                            gLT = 0;//ロスタイム
                        }
                    }
                    gLT++;
                    if (gLT >20) 
                    {
                        gZ0 = gZ0 - gKZ0;
                        gS = 165;
                    }//ロスタイムオーバー
                    break;
                case 175:
                    if (gText.Length > 5)
                    {
                        str = gText.Substring(0, 5);
                        if (str == "DC#1#") {gS = 176; }
                    }
                    gLT++;
                    if (gLT >20) {gS = 170;}//ロスタイムオーバー
                    break;

                case 176:
                    if (gCT > gCTN)
                    {
                        gCT = 0;  
                        gS = 177;
                    }
                    else { gCT = gCT + 1; }//タイムカウンタUP
                    break;


                case 177:
                        gText = "";   
                        msg = System.Text.Encoding.ASCII.GetBytes("DC#0#");
                        stream.Write(msg, 0, msg.Length);//DCモータOFF
                        gS = 178;
                        gLT = 0;//ロスタイム
                    break;

                case 178:
                    if (gText.Length > 4)
                    {
                        str = gText.Substring(0, 5);
                        if (str == "DC#0#") { gS = 180; }
                    }
                    gLT++;
                    if (gLT > 20) { gS = 177; }//ロスタイムオーバー
                    break;

                case 180:
                    if (gCK < gCKN)
                    {
                        gCK = gCK + 1;//回数カウンタUP
                        gS = 182;//追加DCモータON
                    }
                    else
                    {
                        gS = 210;//1点加工完了
                    }
                    break;

                case 182:
                    gZ0 = gZ0 + gKZP;
                    gText = "";
                    msg = System.Text.Encoding.ASCII.GetBytes("MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#");
                    stream.Write(msg, 0, msg.Length);//加工Z追加相対送り
                    gS = 183;
                        
                    gLT = 0;//ロスタイム
                    break;

                case 183:
                    if (gText.Length > 2)
                    {
                        str = gText.Substring(0, 2);
                        if (str == "MC")
                        {
                            gS = 170;
                        }
                    }
                    gLT++;
                    if (gLT >20) 
                    {
                        gZ0 = gZ0 - gKZP;
                        gS = 182;
                    }//ロスタイムオーバー
                    break;



                case 210:
                    if (gi < gW - 1)
                    {
                        gi = gi + 1;
                        gS = 0;//最初に戻る
                    }
                    else//X方向の全点完了
                    {
                        if (gj < gH - 1)
                        {
                            fBX = 1;//バックラッシュフラグON
                            gi = 0;//X方向位置
                            gj = gj + 1;//Y方向位置UP
                            gS = 0;//最初に戻る
                        }
                        else { gS = 211; }//全加工完了！！
                    }
                    //gLT++;
                    //if (gLT > 500) { gS = 180; }//ロスタイムオーバー
                    break;

                case 211:
                    break;

                default:
                    break;
            }


        }

        private void Button5_Click(object sender, EventArgs e)
        {
            byte[] msg = new byte[256];
            msg = System.Text.Encoding.ASCII.GetBytes("MA#0#0#0#");
            stream.Write(msg, 0, msg.Length);
            //SerialPort1.Write("MA#0#0#0#");
            gX0 = 0;//X現在座標
            gY0 = 0;//Y現在座標
            gZ0 = 0;//'Z現在座標
        }
    }
}
